Index: palm/trunk/SCRIPTS/palm_gf_files/palm_gf_tools.py
===================================================================
--- palm/trunk/SCRIPTS/palm_gf_files/palm_gf_tools.py	(revision 4843)
+++ palm/trunk/SCRIPTS/palm_gf_files/palm_gf_tools.py	(revision 4869)
@@ -1,62 +1,18 @@
 #!/usr/bin/env python
-# -*- coding: utf-8 -*-
-#--------------------------------------------------------------------------------#
-# This file is part of the PALM model system.
-#
-# PALM is free software: you can redistribute it and/or modify it under the terms
-# of the GNU General Public License as published by the Free Software Foundation,
-# either version 3 of the License, or (at your option) any later version.
-#
-# PALM is distributed in the hope that it will be useful, but WITHOUT ANY
-# WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR
-# A PARTICULAR PURPOSE.  See the GNU General Public License for more details.
-#
-# You should have received a copy of the GNU General Public License along with
-# PALM. If not, see <http://www.gnu.org/licenses/>.
-#
-# Copyright 1997-2021  Leibniz Universitaet Hannover
-#--------------------------------------------------------------------------------#
-#
-# Current revisions:
-# -----------------
-# 
-# 
-# Former revisions:
-# -----------------
-# $Id$
-# Initial revision
-# 
-# 
-#
-# 
-#
-# Description:
-# ------------
-# 
-#
-# Instructions:
-# -------------
-#
-#------------------------------------------------------------------------------!
-
+from PyQt5 import QtWidgets, uic
+from PyQt5.QtWidgets import QFileDialog
 import sys
+import sqlite3
 import os
-import sqlite3
-from PyQt4 import QtCore, QtGui, uic
-import subprocess as sub
-import palm_gf_conf as configwr
-   
+
 palm_dir = os.getcwd()
 palm_bin = palm_dir + '/trunk/SCRIPTS'
 
-qtCreatorFile = palm_bin + '/palm_gf_files/palm_gf_table.ui'
-
-Ui_MainWindow, QtBaseClass = uic.loadUiType(qtCreatorFile)
-
-class MyApp3(QtGui.QMainWindow, Ui_MainWindow):
-
-    class MyTableWidgetItem(QtGui.QTableWidgetItem):
+
+class MyTable(QtWidgets.QDialog):
+
+    class MyTableWidgetItem(QtWidgets.QTableWidgetItem):
         def __init__(self, text, sortKey):
-            QtGui.QTableWidgetItem.__init__(self, text, QtGui.QTableWidgetItem.UserType)
+            QtWidgets.QTableWidgetItem.__init__(self, text, QtWidgets.QTableWidgetItem.UserType)
             self.sortKey = sortKey
 
@@ -64,33 +20,11 @@
             return self.sortKey < other.sortKey
 
-    def __init__(self):   #     def __init__(self, parent=None):
-        QtGui.QMainWindow.__init__(self)
-        Ui_MainWindow.__init__(self)
-
-        framegm = self.frameGeometry()
-        screen = QtGui.QApplication.desktop().screenNumber(QtGui.QApplication.desktop().cursor().pos())
-        centerpoint = QtGui.QApplication.desktop().screenGeometry(screen).center()
-        framegm.moveCenter(centerpoint)
-
-        #centerpoint = str(centerpoint)
-        #xcenter = centerpoint.split('(')[1].split(',')[0]
-        #ycenter = centerpoint.split('(')[1].split(',')[1].split(')')[0]
-        ##print xcenter, ycenter
-        #centerpoint = QtCore.QPoint(int(xcenter) + 418, int(ycenter))
-        #framegm.moveCenter(centerpoint)
-        self.move(framegm.topLeft())
-
-
-
-        self.setupUi(self)
-        self.pushButton_3.clicked.connect(self.load_result)
-        #self.nx_min.valueChanged.connect(self.check)
-        self.load_trigger()
-        self.pushButton.clicked.connect(self.filter_results)
-        #self.Sortnow_button.clicked.connect(self.sort_order)
-        self.pushButton_2.clicked.connect(self.load_trigger)
-        self.tableWidget.horizontalHeader().setClickable(True)
-
-
+    def __init__(self):
+        super(MyTable, self).__init__()
+        uic.loadUi(palm_bin + '/palm_gf_files/palm_gf_table.ui', self)
+        self.center_window()
+        self.load_limits()
+        self.exec_button.clicked.connect(self.filter_data)
+        # connects labels of table to sorting subroutine
         self.nx_table.clicked.connect(lambda: self.sort_table(str("nx")))
         self.ny_table.clicked.connect(lambda: self.sort_table(str("ny")))
@@ -98,94 +32,87 @@
         self.npex_table.clicked.connect(lambda: self.sort_table(str("npex")))
         self.npey_table.clicked.connect(lambda: self.sort_table(str("npey")))
-        self.npexnpey_table.clicked.connect(lambda: self.sort_table(str("npexnpey")))
+        self.npexnpey_table.clicked.connect(lambda: self.sort_table(str("pxpy")))
         self.np_table.clicked.connect(lambda: self.sort_table(str("np")))
         self.ngpts_table.clicked.connect(lambda: self.sort_table(str("ngpts")))
         self.nxpex_table.clicked.connect(lambda: self.sort_table(str("nxnpex")))
         self.nypey_table.clicked.connect(lambda: self.sort_table(str("nynpey")))
-
-        self.instant()
-
-        self.save_to_file_button.clicked.connect(self.get_path)
-
-    def instant(self):
-        checkfile = open(".palm_gf_tmp", "r")
-        # self.result_label.setText(str(checkfile.readline()))
-        res_text = str(checkfile.readline())  # XXX
-        result_nr = res_text.split(' ')[2]
-        checkfile.close()
-        if int(result_nr) < 100000:
-            self.load_result()
-
-
-
-    def load_trigger(self):
-        pathx = configwr.read_config()
-        pathx = pathx[19]
-
-
-        dtb = str('.palm_gf_data.db')
-        #con = sqlite3.connect("/localdata/.palm_gf_data.db")
-
-        pathx = pathx + '/.palm_gf_data.db'
-        con = sqlite3.connect(pathx)
+        # connects main buttons to subroutines
+        self.load_all_button.clicked.connect(self.load_all)
+        self.reset_button.clicked.connect(self.load_limits)
+        self.save_button.clicked.connect(self.save)
+
+    def center_window(self):
+        # centers window in the middle of screen
+        frame = self.frameGeometry()
+        center = QtWidgets.QDesktopWidget().availableGeometry().center()
+        frame.moveCenter(center)
+        self.move(frame.topLeft())
+
+    def load_limits(self):
+        # reads out the .db and sets limits of results as Min/Max
+        con = sqlite3.connect('palm_gf_data.db')
         c = con.cursor()
         c.execute("SELECT * FROM " + 'grid_limits')
-        mini = c.fetchone()
-        max = c.fetchone()
-        self.nx_min.setValue(mini[0])
-        self.nx_max.setValue(max[0])
-
-        self.ny_min.setValue(mini[1])
-        self.ny_max.setValue(max[1])
-        self.nz_min.setValue(mini[2])
-        self.nz_max.setValue(max[2])
-        self.npex_min.setValue(mini[3])
-        self.npex_max.setValue(max[3])
-        self.npey_min.setValue(mini[4])
-        self.npey_max.setValue(max[4])
-        self.npxnpy_min.setValue(mini[5])
-        self.npxnpy_max.setValue(max[5])
-        self.np_min.setValue(mini[6])
-        self.np_max.setValue(max[6])
-        self.ngpts_min.setValue(mini[7])
-        self.ngpts_max.setValue(max[7])
-        self.nxpex_min.setValue(mini[8])
-        self.nxpex_max.setValue(max[8])
-        self.nypey_min.setValue(mini[9])
-        self.nypey_max.setValue(max[9])
-
-        self.nx_min.setMinimum(mini[0])
-        self.nx_max.setMaximum(max[0])
-        self.ny_min.setMinimum(mini[1])
-        self.ny_max.setMaximum(max[1])
-        self.nz_min.setMinimum(mini[2])
-        self.nz_max.setMaximum(max[2])
-        self.npex_min.setMinimum(mini[3])
-        self.npex_max.setMaximum(max[3])
-        self.npey_min.setMinimum(mini[4])
-        self.npey_max.setMaximum(max[4])
-        self.npxnpy_min.setMinimum(mini[5])
-        self.npxnpy_max.setMaximum(max[5])
-        self.np_min.setMinimum(mini[6])
-        self.np_max.setMaximum(max[6])
-
-        self.ngpts_min.setMinimum(mini[7])
-        self.ngpts_max.setMaximum(max[7])
-        self.ngpts_min.setMaximum(max[7])
-        self.ngpts_max.setMinimum(mini[7])
-
-        self.nxpex_min.setMinimum(mini[8])
-        self.nxpex_max.setMaximum(max[8])
-        self.nxpex_min.setMaximum(max[8])
-        self.nxpex_max.setMinimum(mini[8])
-
-        self.nypey_min.setMinimum(mini[9])
-        self.nypey_max.setMaximum(max[9])
-        self.nypey_min.setMaximum(max[9])
-        self.nypey_max.setMinimum(mini[9])
-
-
-
-
+        Min = c.fetchone()
+        Max = c.fetchone()
+
+        self.nx_min.setValue(Min[0])
+        self.nx_min.setMinimum(Min[0])
+        self.nx_max.setValue(Max[0])
+        self.nx_max.setMaximum(Max[0])
+
+        self.ny_min.setValue(Min[1])
+        self.ny_min.setMinimum(Min[1])
+        self.ny_max.setValue(Max[1])
+        self.ny_max.setMaximum(Max[1])
+
+        self.nz_min.setValue(Min[2])
+        self.nz_min.setMinimum(Min[2])
+        self.nz_max.setValue(Max[2])
+        self.nz_max.setMaximum(Max[2])
+
+        self.npex_min.setValue(Min[3])
+        self.npex_min.setMinimum(Min[3])
+        self.npex_max.setValue(Max[3])
+        self.npex_max.setMaximum(Max[3])
+
+        self.npey_min.setValue(Min[4])
+        self.npey_min.setMinimum(Min[4])
+        self.npey_max.setValue(Max[4])
+        self.npey_max.setMaximum(Max[4])
+
+        self.npxnpy_min.setValue(Min[5])
+        self.npxnpy_min.setMinimum(Min[5])
+        self.npxnpy_max.setValue(Max[5])
+        self.npxnpy_max.setMaximum(Max[5])
+
+        self.np_min.setValue(Min[6])
+        self.np_min.setMinimum(Min[6])
+        self.np_max.setValue(Max[6])
+        self.np_max.setMaximum(Max[6])
+        # try statement, as ngpts could be too huge to handle for PyQt5 (>10^8)
+        try:
+            self.ngpts_min.setValue(Min[7])
+            self.ngpts_min.setMinimum(Min[7])
+            self.ngpts_max.setValue(Max[7])
+            self.ngpts_max.setMaximum(Max[7])
+
+        except OverflowError:
+            self.ngpts_min.setEnabled(False)
+            self.ngpts_max.setEnabled(False)
+            self.ngpts_table.setEnabled(False)
+            self.ngpts_label.setStyleSheet('color: grey')
+            self.exec_button.setEnabled(False)
+            self.status_label.setText('ngpts overflow')
+
+        self.nxpex_min.setValue(Min[8])
+        self.nxpex_min.setMinimum(Min[8])
+        self.nxpex_max.setValue(Max[8])
+        self.nxpex_max.setMaximum(Max[8])
+
+        self.nypey_min.setValue(Min[9])
+        self.nypey_min.setMinimum(Min[9])
+        self.nypey_max.setValue(Max[9])
+        self.nypey_max.setMaximum(Max[9])
 
         con.commit()
@@ -193,172 +120,72 @@
         con.close()
 
-
-
-
-    def check(self):
-        pathx = configwr.read_config()
-        pathx = pathx[19]
-
-        dtb = str('.palm_gf_data.db')
-        #con = sqlite3.connect("/localdata/.palm_gf_data.db")
-        con = sqlite3.connect(pathx + '/.palm_gf_data.db')
+    def load_all(self):
+        # shows all results found in .db file
+        con = sqlite3.connect('palm_gf_data.db')
         c = con.cursor()
-        c.execute("SELECT * FROM " + 'grid_limits')
-        mini = c.fetchone()
-        max = c.fetchone()
-        if self.nx_min.value() < mini[0]:
-
-            self.nx_min.setValue(mini[0])
-
-
-    def process1(self):
-        self.calc_label.setText('loading...')
-        QtGui.QApplication.processEvents()
-
-
-
-    def load_result(self):
-        #print("LOADED!!!")
-        import decimal
-
-        pathx = configwr.read_config()
-        pathx = pathx[19]
-
-        self.setEnabled(False)
-        QtGui.QApplication.processEvents()
-        self.load_trigger()
-        self.process1()
-        database = str('.palm_gf_data.db')
-        conn = sqlite3.connect(pathx + '/.palm_gf_data.db')
-        c = conn.cursor()
         c.execute("SELECT * FROM " + 'grid_current')
-        results = c.fetchall()
-
-        self.tableWidget.setRowCount(len(results))
-
-        i = 0
-        j = 0
-        k = 0
-
-        while i < len(results):
-            line = results[i]
-            while j < 10:
-                var = line[j]
+        data = c.fetchall()
+
+        self.tableWidget.setRowCount(len(data))
+        row_cnt = -1
+        for i in range(0, len(data)):
+            line = data[i]
+            row_cnt += 1
+            for j in range(0, 10):
+                value = line[j]
 
                 if j == 7:
-                    self.tableWidget.setItem(i, j, self.MyTableWidgetItem(str("%.1e" % var), j + i))
-                    #print("%.2e" % int(var), "%.4e" % int(1782))
+                    self.tableWidget.setItem(row_cnt, j, self.MyTableWidgetItem(
+                        str("%.1e" % value), i))
 
                 else:
-                    self.tableWidget.setItem(i, j, self.MyTableWidgetItem(str(var), j+i))
-                #item = self.MyTableWidgetItem(str(var), k)
-                #self.tableWidget.setItem(i, j, item)
-
-                j += 1
-                #if j == 3:
-                    #print(k)
-                #k += 1
-            #k -= 7
-            k += 1
-            j = 0
-            i += 1
+                    self.tableWidget.setItem(row_cnt, j, self.MyTableWidgetItem(
+                        str(value), i))
 
         c.close()
-        conn.close()
-        self.calc_label.setText('loading completed')
-        self.label_11.setText(str(len(results)) + ' results ')
-        self.setEnabled(True)
-        QtGui.QApplication.processEvents()
-
-    def filter_results(self):
-
-        pathx = configwr.read_config()
-        pathx = pathx[19]
-
-        self.setEnabled(False)
-        self.calc_label.setText('calculating...')
-        QtGui.QApplication.processEvents()
-        database = str('.palm_gf_data.db')
-        conn = sqlite3.connect(pathx + '/.palm_gf_data.db')
-        c = conn.cursor()
-        c.execute("SELECT * FROM " + "grid_current")
-        results = c.fetchall()
-        #print(results)
-
-        self.tableWidget.setRowCount(len(results))
-
-        i = 0
-        j = 0
+        con.close()
+        self.tableWidget.setRowCount(row_cnt + 1)
+        self.status_label.setText(str(row_cnt + 1) + ' results loaded')
+
+    def filter_data(self):
+        # filters data according to set Min/Max. Reads out .db to find all fitting data
+        con = sqlite3.connect('palm_gf_data.db')
+        c = con.cursor()
+        c.execute("SELECT * FROM " + 'grid_current')
+        data = c.fetchall()
+
+        self.tableWidget.setRowCount(len(data))
+
         row_cnt = -1
-        while i < len(results):
-            line = results[i]
-
-            if line[0] <= self.nx_max.value():
-
-                if line[0] >= self.nx_min.value():
-
-                    if line[1] <= self.ny_max.value():
-
-                        if line[1] >= self.ny_min.value():
-
-                            if line[2] <= self.nz_max.value():
-
-                                if line[2] >= self.nz_min.value():
-
-                                    if line[3] <= self.npex_max.value():
-
-                                        if line[3] >= self.npex_min.value():
-
-                                            if line[4] <= self.npey_max.value():
-
-                                                if line[4] >= self.npey_min.value():
-
-                                                    if line[5] <= self.npxnpy_max.value():
-
-                                                        if line[5] >= self.npxnpy_min.value():
-
-                                                            if line[6] <= self.np_max.value():
-
-                                                                if line[6] >= self.np_min.value():
-
-                                                                    if line[7] <= self.ngpts_max.value():
-
-                                                                        if line[7] >= self.ngpts_min.value():
-
-                                                                            if line[8] <= self.nxpex_max.value():
-
-                                                                                if line[8] >= self.nxpex_min.value():
-
-                                                                                    if line[9] <= self.nypey_max.value():
-
-                                                                                        if line[9] >= self.nypey_min.value():
-
-                                                                                            row_cnt += 1
-                                                                                            while j < 10:
-                                                                                                var = line[j]
-
-                                                                                                if j == 7:
-                                                                                                    self.tableWidget.setItem(row_cnt, j, self.MyTableWidgetItem(str("%.1e" % var), i))
-
-                                                                                                else:
-                                                                                                    self.tableWidget.setItem(row_cnt, j, self.MyTableWidgetItem(str(var), i))
-
-                                                                                                j += 1
-
-            j = 0
-            i += 1
+        for i in range(0, len(data)):
+            line = data[i]
+            if self.nx_min.value() <= line[0] <= self.nx_max.value():
+                if self.ny_min.value() <= line[1] <= self.ny_max.value():
+                    if self.nz_min.value() <= line[2] <= self.nz_max.value():
+                        if self.npex_min.value() <= line[3] <= self.npex_max.value():
+                            if self.npey_min.value() <= line[4] <= self.npey_max.value():
+                                if self.npxnpy_min.value() <= line[5] <= self.npxnpy_max.value():
+                                    if self.np_min.value() <= line[6] <= self.np_max.value():
+                                        if self.ngpts_min.value() <= line[7] <= self.ngpts_max.value():
+                                            if self.nxpex_min.value() <= line[8] <= self.nxpex_max.value():
+                                                if self.nypey_min.value() <= line[9] <= self.nypey_max.value():
+                                                    row_cnt += 1
+                                                    for j in range(0, 10):
+                                                        value = line[j]
+
+                                                        if j == 7:
+                                                            self.tableWidget.setItem(row_cnt, j, self.MyTableWidgetItem(
+                                                                str("%.1e" % value), i))
+                                                        else:
+                                                            self.tableWidget.setItem(row_cnt, j, self.MyTableWidgetItem(
+                                                                str(value), i))
 
         c.close()
-        conn.close()
+        con.close()
         self.tableWidget.setRowCount(row_cnt + 1)
-        self.setEnabled(True)
-        self.calc_label.setText('calculation completed')
-        self.label_11.setText(str(row_cnt + 1) + ' results')
-        QtGui.QApplication.processEvents()
-
-
+        self.status_label.setText(str(row_cnt + 1) + ' results found')
 
     def sort_table(self, column):
-
+        # with argument as chosen column, read not from table but from .db and reloads sorted data into table
         fnx_mn = self.nx_min.value()
         fnx_mx = self.nx_max.value()
@@ -382,20 +209,14 @@
         nypey_mx = self.nypey_max.value()
 
-
-        if column == str("nx"):
-            sorted_col = "nx"
-
+        if column == 'nx':
+            sorted_col = 'nx'
             if self.nx_table.isChecked() is True:
                 order = " DESC"
-
-            else:
-
-                order = " ASC"
-
-            self.ny_table.setChecked(False)
-            self.nz_table.setChecked(False)
-            self.npex_table.setChecked(False)
-            self.npey_table.setChecked(False)
-            self.npexnpey_table.setChecked(False)
+            else:
+                order = " ASC"
+            self.ny_table.setChecked(False)
+            self.nz_table.setChecked(False)
+            self.npex_table.setChecked(False)
+            self.npey_table.setChecked(False)
             self.np_table.setChecked(False)
             self.ngpts_table.setChecked(False)
@@ -405,10 +226,7 @@
         if column == str("ny"):
             sorted_col = "ny"
-
             if self.ny_table.isChecked() is True:
                 order = " DESC"
-
-            else:
-
+            else:
                 order = " ASC"
 
@@ -425,10 +243,7 @@
         if column == str("nz"):
             sorted_col = "nz"
-
             if self.nz_table.isChecked() is True:
                 order = " DESC"
-
-            else:
-
+            else:
                 order = " ASC"
 
@@ -445,10 +260,7 @@
         if column == str("npex"):
             sorted_col = "npex"
-
             if self.npex_table.isChecked() is True:
                 order = " DESC"
-
-            else:
-
+            else:
                 order = " ASC"
 
@@ -465,31 +277,24 @@
         if column == str("npey"):
             sorted_col = "npey"
-
             if self.npey_table.isChecked() is True:
                 order = " DESC"
-
-            else:
-
-                order = " ASC"
-
-
-            self.ny_table.setChecked(False)
-            self.nz_table.setChecked(False)
-            self.npex_table.setChecked(False)
-            self.nx_table.setChecked(False)
-            self.npexnpey_table.setChecked(False)
-            self.np_table.setChecked(False)
-            self.ngpts_table.setChecked(False)
-            self.nxpex_table.setChecked(False)
-            self.nypey_table.setChecked(False)
-
-        if column == str("npexnpey"):
-            sorted_col = "npxnpy"
-
+            else:
+                order = " ASC"
+
+            self.ny_table.setChecked(False)
+            self.nz_table.setChecked(False)
+            self.npex_table.setChecked(False)
+            self.nx_table.setChecked(False)
+            self.npexnpey_table.setChecked(False)
+            self.np_table.setChecked(False)
+            self.ngpts_table.setChecked(False)
+            self.nxpex_table.setChecked(False)
+            self.nypey_table.setChecked(False)
+
+        if column == str("pxpy"):
+            sorted_col = "pxpy"
             if self.npexnpey_table.isChecked() is True:
                 order = " DESC"
-
-            else:
-
+            else:
                 order = " ASC"
 
@@ -506,10 +311,7 @@
         if column == str("np"):
             sorted_col = "np"
-
             if self.np_table.isChecked() is True:
                 order = " DESC"
-
-            else:
-
+            else:
                 order = " ASC"
 
@@ -526,10 +328,7 @@
         if column == str("ngpts"):
             sorted_col = "ngpts"
-
             if self.ngpts_table.isChecked() is True:
                 order = " DESC"
-
-            else:
-
+            else:
                 order = " ASC"
 
@@ -546,10 +345,7 @@
         if column == str("nxnpex"):
             sorted_col = "nxnpex"
-
             if self.nxpex_table.isChecked() is True:
                 order = " DESC"
-
-            else:
-
+            else:
                 order = " ASC"
 
